<?php
/***************************************************************************
 *                              admin_jabber.php
 *                            -------------------
 *   begin                : Thursday, Feb 15, 2007
 *   copyright            : (C) 2007 nE0sIghT
 *   email                : Jabber_MoD@mail.ru
 *
 *   $Id: admin_jabber.php,v 1.0
 *
 *
 ***************************************************************************/

define('IN_PHPBB', 1);

if( !empty($setmodules) )
{
	$file = basename(__FILE__);
	$module['Jabber']['JConfiguration'] = "{$file}?mode=config";
	$module['Jabber']['JConnection'] = "{$file}?mode=connect";
	$module['Jabber']['JCheck'] = "{$file}?mode=test";
	return;
}

//
// Let's set the root dir for phpBB
//
$phpbb_root_path = "./../";
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
include($phpbb_root_path . 'includes/functions_selects.'.$phpEx);

$mode = (isset($HTTP_POST_VARS['mode'])) ? stripslashes($HTTP_POST_VARS['mode']) : ((isset($HTTP_GET_VARS['mode'])) ? stripslashes($HTTP_GET_VARS['mode']) : '');

$sql = "SELECT * 
	FROM " . CONFIG_TABLE . "
	WHERE config_name IN " . ($mode == "config" ? '("default_jabber_lang", "board_jabber_form", "jabber_activation", "disable_email", "jabber_post_len")' : '("jabber_ssl", "jabber_server", "jabber_port", "jabber_resource", "jabber_username", "jabber_password")');
if(!$result = $db->sql_query($sql))
{
	message_die(CRITICAL_ERROR, "Could not query config information in admin_board", "", __LINE__, __FILE__, $sql);
}
else
{
	while( $row = $db->sql_fetchrow($result) )
	{
		$config_name = $row['config_name'];
		$config_value = $row['config_value'];
		$default_config[$config_name] = isset($HTTP_POST_VARS['submit']) ? str_replace("'", "\'", $config_value) : $config_value;

		$new[$config_name] = ( isset($HTTP_POST_VARS[$config_name]) ) ? $HTTP_POST_VARS[$config_name] : $default_config[$config_name];

		if( isset($HTTP_POST_VARS['submit']) && $config_name != "jabber_register")
		{
			$sql = "UPDATE " . CONFIG_TABLE . " SET
				config_value = '" . str_replace("\'", "''", $new[$config_name]) . "'
				WHERE config_name = '$config_name'";
			if( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Failed to update jabber configuration for $config_name", "", __LINE__, __FILE__, $sql);
			}
		}
	}

	if( isset($HTTP_POST_VARS['submit']) )
	{
		$message = $lang['Jabber_updated'] . "<br /><br />" . sprintf($lang['Click_return_jabber_config'], "<a href=\"" . append_sid("admin_jabber.$phpEx?mode=$mode") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
}

if($mode == "config")
{
	$jabber_lang_select = jabber_language_select($new['default_jabber_lang'], 'default_jabber_lang'); //Jabber MoD />

	$jabber_activation_yes = ( $new['jabber_activation'] ) ? "checked=\"checked\"" : "";
	$jabber_activation_no = ( !$new['jabber_activation'] ) ? "checked=\"checked\"" : "";
	$disable_email_yes = ( $new['disable_email'] ) ? "checked=\"checked\"" : "";
	$disable_email_no = ( !$new['disable_email'] ) ? "checked=\"checked\"" : "";
	$jabber_form_yes = ( $new['board_jabber_form'] ) ? "checked=\"checked\"" : "";
	$jabber_form_no = ( !$new['board_jabber_form'] ) ? "checked=\"checked\"" : "";
	$jabber_post_len = intval($new['jabber_post_len']);

	$template->set_filenames(array(
		"body" => "admin/jabber_config_body.tpl")
	);

	$template->assign_vars(array(
		"L_JABBER_TITLE" => $lang['Jabber_config_title'],
		//"L_JABBER_EXPLAIN" => $lang['Jabber_config_explain'],
		"L_FORUM_SETTINGS" => $lang['Jabber_config_header'],
		"L_BOARD_JABBER_ACTIVATION" => $lang['Jabber_activation'],
		"L_BOARD_JABBER_ACTIVATION_EXPLAIN" => $lang['Jabber_activation_explain'],
		"L_BOARD_JABBER_FORM" => $lang['Board_jabber_form'],
		"L_BOARD_JABBER_FORM_EXPLAIN" => $lang['Board_jabber_form_explain'],
		"L_BOARD_DISABLE_EMAIL" => $lang['Disable_email'],
		"L_BOARD_DISABLE_EMAIL_EXPLAIN" => $lang['Disable_email_explain'],
		"L_DEFAULT_JABBER_LANGUAGE" => $lang['Default_jabber_language'],
		"L_JABBER_POST_LEN" => $lang['Jabber_post_len'],
		"L_JABBER_POST_LEN_EXPLAIN" => $lang['Jabber_post_len_explain'],

		"JABBER_ACTIVATION_ENABLE" => $jabber_activation_yes,
		"JABBER_ACTIVATION_DISABLE" => $jabber_activation_no,
		"DISABLE_EMAIL_YES" => $disable_email_yes,
		"DISABLE_EMAIL_NO" => $disable_email_no,
		"BOARD_JABBER_FORM_ENABLE" => $jabber_form_yes,
		"BOARD_JABBER_FORM_DISABLE" => $jabber_form_no,
		"JABBER_LANG_SELECT" => $jabber_lang_select,
		"JABBER_POST_LEN" => $jabber_post_len)
	);
}
else if($mode == "connect")
{
	$jabber_ssl_yes = ( $new['jabber_ssl'] ) ? "checked=\"checked\"" : "";
	$jabber_ssl_no = ( !$new['jabber_ssl'] ) ? "checked=\"checked\"" : "";

	$test_results = "";
	if(isset($_POST['test_settings']))
	{
		include($phpbb_root_path . 'includes/class.jabber.'.$phpEx);

		$jabber = new jabber;
		$jabber->server         = $new['jabber_server'];
		$jabber->port           = $new['jabber_port'];
		$jabber->use_ssl        = $new['jabber_ssl'];

		$jabber->username       = $new['jabber_username'];
		$jabber->password       = $new['jabber_password'];
		$jabber->resource       = $new['jabber_resource'];
		$jabber->enable_logging = NULL;

		//$time[0] = time();
		if($jabber->Connect())
		{
			//$time[1] = time();
			if($jabber->SendAuth())
			{
				$time[2] = time();
				if($jabber->SendPresence("invisible", NULL, ""))
					$test_results = "<font color='green'>{$lang['Jabber_connect_success']}</font>";
				else
					$test_results = "<font color='red'>{$lang['Jabber_presence_failed']}</font>";
				//$time[3] = time();
			}
			else
			{
				if(intval($_POST['jabber_register']))
				{
					if($jabber->AccountRegistration() == 2)
						$test_results = "<font color='green'>{$lang['Jabber_registration_success']}</font>";
					else
						$test_results = "<font color='red'>{$lang['Jabber_registration_failed']}</font>";
				}
				else
					$test_results = "<font color='red'>{$lang['Jabber_auth_failed']}</font>";
			}
			$jabber->Disconnect();
		}
		else
			$test_results = "<font color='red'>{$lang['Jabber_connect_failed']}</font>";
		//echo ($time[1]-$time[0]) . "<br />" . ($time[2]-$time[1]) . "<br />" . ($time[3]-$time[2]);
	}

	$template->set_filenames(array(
		"body" => "admin/jabber_connect_body.tpl")
	);

	$template->assign_vars(array(
		"L_JABBER_TITLE" => $lang['Jabber_connection_title'],
		//"L_JABBER_EXPLAIN" => $lang['Jabber_connection_explain'],
		"L_JABBER_SETTINGS" => $lang['Jabber_connection_header'],

		"L_JABBER_TEST_RESULTS" => $lang['Jabber_test_results'],
		"S_HIDE" => isset($_POST['test_settings']) ? "" : "style='display:none'",
		"JABBER_TEST_RESULTS" => $test_results,

		"L_JABBER_SERVER" => $lang['Jabber_server'],
		"L_JABBER_PORT" => $lang['Jabber_port'],
		"L_JABBER_SSL" => $lang['Jabber_ssl'],
		"L_JABBER_SSL_EXPLAIN" => $lang['Jabber_ssl_explain'],
		"S_JABBER_SSL_YES" => $jabber_ssl_yes,
		"S_JABBER_SSL_NO" => $jabber_ssl_no,
		"L_JABBER_RESOURCE" => $lang['Jabber_resource'],
		"L_JABBER_RESOURCE_EXPLAIN" => $lang['Jabber_resource_explain'],
		"L_JABBER_USERNAME" => $lang['Jabber_username'],
		"L_JABBER_USERNAME_EXPLAIN" => $lang['Jabber_username_explain'],
		"L_JABBER_PASSWORD" => $lang['Jabber_password'],
		"L_JABBER_PASSWORD_EXPLAIN" => $lang['Jabber_password_explain'],
		"L_TEST_SETTINGS" => $lang['Jabber_test_settings'],

		"L_JABBER_REGISTER" => $lang['Jabber_register'],
		"L_TEST_CONNECT" => $lang['Jabber_test_connect'],

		"JABBER_SERVER" => $new['jabber_server'],
		"JABBER_PORT" => $new['jabber_port'],
		"JABBER_RESOURCE" => $new['jabber_resource'],
		"JABBER_USERNAME" => $new['jabber_username'],
		"JABBER_PASSWORD" => $new['jabber_password'],
		"S_JABBER_SSL_YES" => $jabber_ssl_yes,
		"S_JABBER_SSL_NO" => $jabber_ssl_no,
		"S_JABBER_SSL_DISABLED" => in_array("ssl", stream_get_transports()) ? "" : "disabled='disabled'")
	);
}
else if($mode == "test")
{
	$available = "<font color='green'>{$lang['Jabber_check_available']}</font>";
	$unavailable = "<font color='red'>{$lang['Jabber_check_unavailable']}</font>";
	$passed = "<font color='yellow'>{$lang['Jabber_check_passwd']}</font>";

	$check_result = "";

	if(function_exists("fsockopen") && function_exists("fread") && function_exists("fwrite"))
		$socket_test = $available;
	else
	{
		$socket_test = $unavailable;
		$check_result .= $lang['Jabber_socket_unavailable'] . "<br />";
	}

	if(function_exists("mhash"))
		$mhash_test = $available;
	else
	{
		$mhash_test = $unavailable;
		$check_result .= $lang['Jabber_mhash_unavailable'] . "<br />";
	}

	if(function_exists("iconv"))
		$iconv_test = $available;
	else
	{
		if(defined("JABBER_ICONV"))
			$iconv_test = $passed;
		else
		{
			$iconv_test = $unavailable;
			$check_result .= $lang['Jabber_iconv_unavailable'] . "<br />";
		}
	}

	if(in_array("ssl", stream_get_transports()))
		$ssl_test = $available;
	else
	{
		$ssl_test = $unavailable;
		$check_result .= $lang['Jabber_ssl_unavailable'] . "<br />";
	}

	if(!strlen($check_result))
		$check_result = "<b><font color='green'>" . $lang['Jabber_tests_passed'] . "</font></b>";
	else
		$check_result = "<b><font color='red'>" . $lang['Jabber_tests_failed'] . "</font></b><br />" . $check_result;

	$template->set_filenames(array(
		"body" => "admin/jabber_test_body.tpl")
	);

	$template->assign_vars(array(
		"L_JABBER_TITLE" 		=> $lang['Jabber_test_title'],
		//"L_JABBER_EXPLAIN" 		=> $lang['Jabber_test_explain'],
		"L_JABBER_CHECKS" 		=> $lang['Jabber_checks_header'],
		"L_JABBER_RESULTS" 		=> $lang['Jabber_results_header'],

		"L_JABBER_TEST_SOCKET" 		=> $lang['Jabber_test_socket'],
		"L_JABBER_TEST_MHASH" 		=> $lang['Jabber_test_mhash'],
		"L_JABBER_TEST_ICONV" 		=> $lang['Jabber_test_iconv'],
		"L_JABBER_TEST_SSL" 		=> $lang['Jabber_test_ssl'],

		"L_JABBER_RESULT_SOCKET" 	=> $socket_test,
		"L_JABBER_RESULT_MHASH"		=> $mhash_test,
		"L_JABBER_RESULT_ICONV" 	=> $iconv_test,
		"L_JABBER_RESULT_SSL" 		=> $ssl_test,

		"L_JABBER_TEST_RESULTS"		=> $check_result)
	);
}
else
{
	message_die(GENERAL_MESSAGE, $lang['Jabber_unknown_mode']);
}

$template->assign_vars(array(
	"S_CONFIG_ACTION" => append_sid("admin_jabber.$phpEx?mode=$mode"),

	"L_YES" => $lang['Yes'],
	"L_NO" => $lang['No'],
	"L_ENABLED" => $lang['Enabled'],
	"L_DISABLED" => $lang['Disabled'],

	"L_SUBMIT" => $lang['Submit'],
	"L_RESET" => $lang['Reset'])
);

$template->pparse("body");

include('./page_footer_admin.'.$phpEx);
?>
